# Required order: options, queueing, translation and filtering.

# Macros
###############################################################################

# Interfaces
###################
# External interface
IF_WLAN = "{{ ansible_interfaces[0] }}"

# Internal interfaces
IF_LAN  = "{{ ansible_interfaces[1] }}"
IF_WIFI = "{{ ansible_interfaces[2] }}"
IF_DMZ  = "{{ ansible_interfaces[3] }}"

# Hosts / Ports
###################
HOST_NAS        = "{{ ip.nas }}"
HOST_NEXTCLOUD  = "{{ ip.nextcloud }}"
HOST_GITLAB     = "{{ ip.gitlab }}"

SSH_HOST_WORK = "{ 192.168.1.30 172.21.0.213 }"

PLEX_PORT = "32400"
PLEX_HOST = "{" $HOST_NAS "}"

# States and Types
###################
TYPE_ICMP = "icmp-type 8 code 0"
MTUD_ICMP = "icmp-type 3 code 4"
STATE_TCP = "flags S/SA modulate state"
STATE_UDP = "keep state"

# Stateful Tracking Options (STO)
###################
STO_FTP    = "(tcp.established 7200)"
STO_EXT_IF = "(max 9000, source-track rule, max-src-conn   2000, max-src-nodes 14)"
STO_INT_IF = "(max 150,  source-track rule, max-src-conn   50,   max-src-nodes 14, max-src-conn-rate 75/20)"
STO_SSH    = "(max 5,    source-track rule, max-src-states 5,    max-src-nodes 5,  max-src-conn-rate  5/60)"
STO_WEB    = "(max 500,  source-track rule, max-src-states 50,   max-src-nodes 75, max-src-conn-rate 120/100, overload <BLOCKTEMP> flush global)"

# Tables
###################
table <BLOCKTEMP> counters
table <BLOCKPERM> counters file "/var/pf/block_permanent"

{% if is_production %}
# Referece: https://tools.ietf.org/html/rfc6890
table <IPv4_SPECIAL_ADDRESS> { \
        0.0.0.0/8              \
        10.0.0.0/8             \
        100.64.0.0/10          \
        127.0.0.0/8            \
        169.254.0.0/16         \
        172.16.0.0/12          \
        192.0.0.0/24           \
        192.0.2.0/24           \
        192.88.99.0/24         \
        192.168.0.0/16         \
        198.18.0.0/15          \
        198.51.100.0/24        \
        203.0.113.0/24         \
        240.0.0.0/4            \
        255.255.255.255/32     \
}

# Referece: https://tools.ietf.org/html/rfc6890
table <IPv6_SPECIAL_ADDRESS> { \
        ::1/128                \
        ::/128                 \
        64:ff9b::/96           \
        ::ffff:0:0/96          \
        100::/64               \
        2001::/23              \
        2001::/32              \
        2001:2::/48            \
        2001:db8::/32          \
        2001:10::/28           \
        2002::/16              \
        fc00::/7               \
        fe80::/10              \
}

{% endif %}

# Options
###############################################################################

# Misc Options
###################
set skip on lo0
set debug err
set reassemble yes
set block-policy drop
set loginterface $IF_WLAN
set state-policy if-bound
set fingerprints "/etc/pf.os"
set ruleset-optimization none

# Timeout Options for normal operations
###################
set optimization normal
set timeout { tcp.established 600, tcp.closing 60 }

# Timeout Options for anti SYN DDoS with short timeouts and increased states
#
# NOTE: Upon initial test, using those setting doesn't allow me to log into the Plex Web App.
###################
#set optimization aggressive
#set timeout { adaptive.end 120000, interval 2, tcp.tsdiff 5, tcp.first 5, tcp.closing 5, tcp.closed 5, tcp.finwait 5, tcp.established 4200 }
#set limit   { states 100000, src-nodes 100000 }


# Translation and Filtering
###############################################################################

antispoof quick for { $IF_WLAN $IF_LAN $IF_WIFI $IF_DMZ }

# Blocking spoofed packets: enable "set state-policy if-bound" above
###################
block drop in log quick on ! $IF_WLAN inet from ($IF_WLAN:network) to any

# Block to/from illegal sources/destinations
###################
{% if is_production %}
# Those two blocks will cause VM testing some problem.
# Won't be able to SSH from the host to the VM because of the restricted IP.
block drop in     quick on $IF_WLAN inet           from <IPv4_SPECIAL_ADDRESS> to any
block drop in     quick on $IF_WLAN inet6          from <IPv6_SPECIAL_ADDRESS> to any

{% endif %}
block drop in     quick on $IF_WLAN inet proto tcp from <BLOCKTEMP> to any port != ssh
block drop in     quick on $IF_WLAN inet proto tcp from <BLOCKPERM> to any port != ssh
block drop in     quick on $IF_WLAN inet proto udp from <BLOCKTEMP> to any port != ssh
block drop in     quick on $IF_WLAN inet proto udp from <BLOCKPERM> to any port != ssh

block drop in     quick on $IF_WLAN inet           from any to 255.255.255.255
block drop in log quick on $IF_WLAN inet           from urpf-failed to any
block drop in log quick on $IF_WLAN inet           from no-route to any

# BLOCK all in on external interface by default and log
###################
block drop log on $IF_WLAN all

# Network Address Translation (NAT with outgoing source port randomization)
###################
match out log on $IF_WLAN inet from ! ($IF_WLAN:network) to any tag INTERNAL_TO_ANY nat-to ($IF_WLAN:0)

# Packet normalization (i.e.: scrubbing)
###################
# remove "min-ttl 64" if you need native traceroute functions or just use "traceroute -I" instead
match in log on $IF_WLAN all set (tos 0xb8) scrub (no-df random-id min-ttl 64 reassemble tcp max-mss 1440)


# $IF_WLAN
#######################################

# Incoming
###################
pass in log on $IF_WLAN inet proto tcp  from !($IF_WLAN)     to ($IF_WLAN) port https $STATE_TCP $STO_WEB  rdr-to lo0
pass in log on $IF_WLAN inet proto tcp  from !($IF_WLAN)     to ($IF_WLAN) port www   $STATE_TCP $STO_WEB  rdr-to lo0

# Plex: Allow remote access to Plex webapp.
pass in log on $IF_WLAN inet proto tcp  from !($IF_WLAN)     to ($IF_WLAN) port $PLEX_PORT $STATE_TCP $STO_WEB  rdr-to $PLEX_HOST port $PLEX_PORT

# SSH: Allow remote access to the router via SSH, but only from specific host IPs.
pass in log on $IF_WLAN inet proto tcp  from  $SSH_HOST_WORK to ($IF_WLAN) port ssh   $STATE_TCP $STO_SSH  rdr-to lo0

# As long as we're using state tracking, we shouldn't have to allow any ICMP
# messages in explictly, except PING if we want it, since they all should only
# come up in response to a tracked state.
#pass in log on $IF_WLAN inet proto icmp from !($IF_WLAN)    to ($IF_WLAN) $TYPE_ICMP  $STATE_UDP
#pass in log on $IF_WLAN inet proto icmp from !($IF_WLAN)    to ($IF_WLAN) $MTUD_ICMP  $STATE_UDP

# Outgoing
###################
# Outgoing connection originating from the router are not allowed for rules
# tagged as LAN_TO_ANY.
pass out log on $IF_WLAN inet proto tcp  from ($IF_WLAN) to !($IF_WLAN) port ssh    $STATE_TCP $STO_EXT_IF tagged INTERNAL_TO_ANY
pass out log on $IF_WLAN inet proto tcp  from ($IF_WLAN) to !($IF_WLAN) port ftp    $STATE_TCP $STO_FTP    tagged INTERNAL_TO_ANY
pass out log on $IF_WLAN inet proto udp  from ($IF_WLAN) to !($IF_WLAN)             $STATE_UDP $STO_EXT_IF tagged INTERNAL_TO_ANY
pass out log on $IF_WLAN inet proto icmp from ($IF_WLAN) to !($IF_WLAN)             $STATE_UDP $STO_EXT_IF tagged INTERNAL_TO_ANY

# When this rule was tagged for internal network only, pkg_add wasn't working
# anymore...
pass out log on $IF_WLAN inet proto tcp  from ($IF_WLAN) to !($IF_WLAN)             $STATE_TCP $STO_EXT_IF

# The DNS service is executed on the router, so that traffic is allowed from
# the router to the web.
pass out log on $IF_WLAN inet proto udp  from ($IF_WLAN) to !($IF_WLAN) port domain $STATE_UDP $STO_EXT_IF


# $IF_LAN
#######################################

# Incoming
###################

# Outgoing
###################


# $IF_WIFI
#######################################

# Incoming
###################

# Outgoing
###################


# $IF_DMZ
#######################################

# Incoming
###################

# Outgoing
###################
